Package ec.es

# Class ESSelection

java.lang.Object
ec.BreedingSource
ec.SelectionMethod
ec.es.ESSelection

All Implemented Interfaces:
  `Prototype`, `Setup`, `RandomChoiceChooserD`, `Serializable`, `Cloneable`

public class ESSelection extends SelectionMethod
ESSelection is a special SelectionMethod designed to be used with evolutionary strategies-type breeders.

To do evolution strategies evolution, the breeding pipelines should contain at least one ESSelection selection method. While a child is being generated by the pipeline, the ESSelection object will return a parent from the pool of mu parents. The particular parent is chosen round-robin, so all the parents will have an equal number of children. It's perfectly fine to have more than one ESSelection object in the tree, or to call the same one repeatedly during the course of generating a child; all such objects will consistently return the same parent. They only increment to the next parent in the pool of mu parents after the child has been created from the pipeline. You can also mix ESSelection operators with other operators (like Tournament Selection). But you ought to have at least one ESSelection operator in the pipeline -- else it wouldn't be Evolution Strategies, would it?

Default Base
es.select

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `P_ESSELECT`

  ### Fields inherited from class ec.SelectionMethod

  `INDS_PRODUCED, KEY_PARENTS`

  ### Fields inherited from class ec.BreedingSource

  `NO_PROBABILITY, P_PROB, probability`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ESSelection()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Parameter`
  `defaultBase()`
  Returns the default base for this prototype.
  `void`
  `prepareToProduce(EvolutionState state, int subpopulation, int thread)`
  A default version of prepareToProduce which does nothing.
  `int`
  `produce(int subpopulation, EvolutionState state, int thread)`
  An alternative form of "produce" special to Selection Methods; selects an individual from the given subpopulation and returns its position in that subpopulation.
  `int`
  `produceWithoutCloning(int min, int max, int subpopulation, ArrayList<Individual> inds, EvolutionState state, int thread, HashMap<String,Object> misc)`

  ### Methods inherited from class ec.SelectionMethod

  `finishProducing, produce, produces, typicalIndsProduced`

  ### Methods inherited from class ec.BreedingSource

  `clone, fillStubs, getProbability, pickRandom, preparePipeline, setProbability, setup, setupProbabilities`

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### P_ESSELECT

    public static final String P_ESSELECT
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### ESSelection

    public ESSelection()

- ## Method Details

  - ### defaultBase

    public Parameter defaultBase()
    Description copied from interface: `Prototype`
    Returns the default base for this prototype. This should generally be implemented by building off of the static base() method on the DefaultsForm object for the prototype's package. This should be callable during setup(...).

  - ### prepareToProduce

    public void prepareToProduce(EvolutionState state, int subpopulation, int thread)
    Description copied from class: `SelectionMethod`
    A default version of prepareToProduce which does nothing.
    Overrides:
      `prepareToProduce` in class `SelectionMethod`

  - ### produce

    public int produce(int subpopulation, EvolutionState state, int thread)
    Description copied from class: `SelectionMethod`
    An alternative form of "produce" special to Selection Methods; selects an individual from the given subpopulation and returns its position in that subpopulation.
    Specified by:
      `produce` in class `SelectionMethod`

  - ### produceWithoutCloning

    public int produceWithoutCloning(int min, int max, int subpopulation, ArrayList<Individual> inds, EvolutionState state, int thread, HashMap<String,Object> misc)
    Overrides:
      `produceWithoutCloning` in class `SelectionMethod`